<SettingsModal tabs={[ "Basic", "Roles", "Guild Styles" ]} bind:selected=tab>
  {#if tab == "Basic"}
  <div class="basic-flex">
    <div class="avatar-flex">
      <AvatarUploader iconUrl={guildIconUrl} bind:file=guildIcon />
    </div>
    <div class="options-flex">
      <TextInput name="Name" value={modalContext.name} bind:value=name />
      <Button {disabled} on:click="edit(modalContext, {name}, guildIcon)" text="Apply" />
    </div>
  </div>
  {:elseif tab == "Roles"}
  <div class="roles-flex">
    <div class="role-list">
      <CreateRoleButton guildId={modalContext.id} on:selectRole="set({roleId: event})" /> {#each memoryRoles as role (role.id)}
      {role.position}
      <RoleSelection guildId={modalContext.id} selected={roleId==role.id} dragging={role.id==dragging} id={role.id} on:hover="setDraggingPosition(event, dragging, role.position)"
       on:dragstart="set({dragging: role.id, draggingPosition: role.position})" on:drop="setPosition(role.id, modalContext.id, draggingPosition)"
       on:click="set({roleId: event})" name={role.name} /> {/each}
    </div>
    <div class="role-settings">
      {#if roles.length}
      <RoleSettings id={roleId || roles[0].id} /> {/if}
    </div>
  </div>
  {:elseif tab == "Guild Styles"}
  <div class="guild-options">
    <span class="explain-text">
      Write custom CSS for your guild here. Try not to change too much or force people to use a theme you like, themes should be installed by the user so that they can be used throughout the app!
    </span>
    <CodeEditor language="css" value={localStyle} on:save="updateStyles(event, modalContext)" />
  </div>
  {:else} Oopsie Woopsie {/if}
</SettingsModal>

<script>
  import StyleStore from "../../stores/StyleStore";
  import SettingsModal from "./SettingsModal.svelte";
  import TextInput from "../forms/TextInput.svelte";
  import Button from "../forms/Button.svelte";
  import RestClient from "../../js/RestClient";
  import GuildStore from "../../stores/GuildStore";
  import AvatarUploader from "../forms/AvatarUploader.svelte";
  import RoleSelection from "../RoleSelection.svelte";
  import RoleSettings from "../RoleSettings.svelte";
  import RoleStore from "../../stores/RoleStore";
  import CreateRoleButton from "../CreateRoleButton.svelte";
  import env from "../../js/constants";
  import CodeEditor from "../forms/CodeEditor.svelte";

  export default {
    components: {
      SettingsModal,
      TextInput,
      Button,
      RoleSettings,
      CreateRoleButton,
      RoleSelection,
      AvatarUploader,
      CodeEditor
    },
    computed: {
      guildId({modalContext}) {
        return modalContext.id;
      },
      guildIconUrl({modalContext}) {
        return modalContext.icon
          ? `${env.API_BASE}/icons/${modalContext.id}`
          : null;
      },
      memoryRoles({dragging, draggingPosition, roles}) {
        if (!dragging) {
          return roles;
        }
        const roleOrdering = roles.map(role => role.id);
        const draggingRole = roles[roleOrdering.indexOf(dragging)];
        const newRoles = [];

        for (const index in roleOrdering) {
          const currentRole = roles[index];

          // These need to be flipped depending on which will make the user's cursor be over it
          // The issue is that we have duplicate positions

          if (roleOrdering[index] != dragging) {
            newRoles.push(currentRole);
          }
          if (currentRole.position == draggingPosition) {
            newRoles.push({
              ...draggingRole,
              position: draggingPosition
            });
          }
        }
        return newRoles;
      }
    },
    onstate({current, changed}) {
      console.log("STATE CHANGE FOR GUILDSETTINGSMODAL", current);
      if (changed.guildId) {
        StyleStore.subscribeComponent(
          current.guildId,
          this,
          this.onStyleChangeListener,
          "g"
        );
        RoleStore.subscribeComponent(
          current.guildId,
          this,
          this.onChangeListener,
          "g"
        );
      }
    },
    methods: {
      async updateStyles(styles, modalContext) {
        const res = await RestClient.patch(`/guilds/${modalContext.id}/styles`, {
          localStyle: styles
        });
        StyleStore.slurp({id: modalContext.id, localStyle: res.localStyle});
      },
      onStyleChangeListener() {
        const guildId = this.get().modalContext.id;
        const style = StyleStore.getItem(guildId);
        console.log(style);
        this.set({
          localStyle: (style && style.localStyle) || ""
        });
      },
      onChangeListener() {
        console.log("GuildSettingsModal: RoleStore changed");
        const guildId = this.get().modalContext.id;
        const roles = RoleStore.getRoles(guildId);
        console.log(roles);
        if (roles) {
          this.set({
            roles: roles.sort((a, b) => a.position - b.position)
          });
        }
      },
      async setPosition(roleId, guildId, position) {
        if (!roleId) {
          return;
        }
        this.set({dragging: undefined, draggingPosition: undefined});
        const res = await RestClient.patch(`/guilds/${guildId}/roles/${roleId}`, {
          position
        });
        RoleStore.slurp(res);
      },
      setDraggingPosition(event, dragging, newPosition) {
        console.log("SET DRAGGING...");
        if (!dragging) {
          return;
        }
        event.preventDefault();
        this.set({
          draggingPosition: newPosition
        });
      },
      async edit(guild, options, file) {
        const diff = {};
        let modified = false;
        for (const key in options) {
          if (guild[key] != options[key]) {
            diff[key] = options[key];
            modified = true;
          }
        }
        if (!modified && file === undefined) {
          return;
        }
        this.set({disabled: true});

        if (modified) {
          try {
            await RestClient.patch(`/guilds/${guild.id}`, diff);
            GuildStore.slurp({id: guild.id, ...diff});
          } catch (err) {
            console.error(err);
            return this.set({disabled: false});
          }
        }
        if (file !== undefined) {
          await RestClient.put(`/guilds/${guild.id}/icon`, file);
        }
        this.set({disabled: false});
        this.store.set({modal: null});
      }
    },
    data() {
      return {
        roles: []
      };
    }
  };
</script>

<style>
  .basic-flex {
    display: flex;
  }
  .options-flex {
    margin-left: 2em;
  }
  .avatar-flex,
  .options-flex {
    display: inline-block;
  }

  .role-list {
    flex-grow: 1;
  }

  .role-settings {
    flex-grow: 3;
  }

  .roles-flex {
    display: flex;
  }

  .explain-text {
    font-size: 0.8em;
    color: #9d9e9f;
  }

  .guild-options {
    height: 90vh;
    display: flex;
    flex-direction: column;
  }
</style>
